/** \file
 * \brief Public header for NPS BPP class (and Obex too, for now)
 */

/*
	some in-house, non-doxygen info here
 */

/** \defgroup Protocols Protocols
 *  \{
 */

class BPP {
/** 
 * \todo Which of these methods takes time before returning?  What are
 * threading requirements?  Also, should this class be static (no need
 * to instantiate an instance)?
 */
public:
    new(void);
    int handleObexData(Uint32 obexChannel, Uint8 obexOpcode, int dataLength,
	HEADER_TYPE headerID, Uint8 *data, Boolean finalFlag);
	///< called by OBEX
    getReferencedObject(char *objectIdentifierUtf8, Uint32 offset,
	char *pBuffer, Sint32 *pactualBytesRead, Uint32 *pFileSize);
	///< called by application to read object data
};

class Obex {
public:
    new(void);
    sendResponse(Uint32 channel, int *dataLength, Uint8 *headerID, Uint8 *data);
    Boolean getReferencedObject(Uint8 *type, Uint16 typeLength, Uint16 *name,
    	Uint16 nameLength, Uint32 offset, Uint32 count,
	Uint8 *data, Uint32 *dataLength);
    Boolean isBppJobActive(void);
}

/** \} */

/*
 * Local Variables:
 * mode: C
 * tab-width: 8
 * c-indent-level: 4
 * c-basic-offset: 4
 * End:
 */
/* Used by some versions of vim: set tabstop=8 shiftwidth=4: */
